Bug 858127 - Review Request: groovy18 - Dynamic language for the Java Platform
Review Request: groovy18 - Dynamic language for the Java Platform
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Björn "besser82" Esser
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 985087
  Show dependency treegraph
 
Reported: 2012-09-17 23:15 EDT by gil cattaneo
Modified: 2013-10-05 08:07 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-07-19 09:25:17 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
fedora: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)
Java Compat-pkg (1.09 KB, patch)
2013-06-11 06:59 EDT, Björn "besser82" Esser
no flags Details | Diff

  None (edit)
Description gil cattaneo 2012-09-17 23:15:55 EDT
Spec URL: http://gil.fedorapeople.org/groovy18.spec
SRPM URL: http://gil.fedorapeople.org/groovy18-1.8.8-1.fc16.src.rpm
Description: Groovy is an agile and dynamic language for the Java Virtual Machine,
built upon Java with features inspired by languages like Python, Ruby and
Smalltalk.  It seamlessly integrates with all existing Java objects and
libraries and compiles straight to Java bytecode so you can use it anywhere
you can use Java.
Fedora Account System Username: gil
gmaven and gradle build/requires
Comment 1 Pavel Alexeev 2012-12-26 13:59:02 EST
1.8.7 groovy already in Fedora (and 1.8.8 in rawhide). Is it this request stil actual?
Comment 2 gil cattaneo 2012-12-26 14:29:27 EST
yes because groovy 2.x (requires asm4) break a lot of packages...
e.g. gradle, gmaven, ...
Comment 3 gil cattaneo 2013-04-20 14:41:25 EDT
Spec URL: http://gil.fedorapeople.org/groovy18.spec
SRPM URL: http://gil.fedorapeople.org/groovy18-1.8.9-1.fc18.src.rpm

- Update to 1.8.9
Comment 4 Björn "besser82" Esser 2013-06-11 05:43:28 EDT
Package is fine, besides two small non-blockers to be OK when fixed in SCM:

  * spelling-error %description: 's!bytecode!byte-code!'
  * javadoc subpackages should not have Requires: jpackage-utils

#####

Package Review
==============

Legend:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Javadoc subpackages should not have Requires: jpackage-utils
  Note: jpackage-utils requires are automatically generated by the buildsystem
  See: https://fedoraproject.org/wiki/Packaging:Java


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Fully versioned dependency in subpackages, if present.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     groovy18-javadoc

     ---> false positive

[x]: Package complies to the Packaging Guidelines
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Apache (v2.0)", "BSD (2 clause)", "Unknown or generated". 177 files have
     unknown license. Detailed output of licensecheck in
     /home/bjoern.esser/fedora/review/858127-groovy18/licensecheck.txt

     ---> everything is fine here.

[x]: License file installed when any subpackage combination is installed.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: If the package is under multiple licenses, the licensing breakdown must
     be documented in the spec.
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[!]: Requires correct, justified where necessary.

     ---> javadoc must not Requires: jpackage-utils, see above

[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 40960 bytes in 5 files.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

Java:
[x]: Packages have proper BuildRequires/Requires on jpackage-utils
[x]: Fully versioned dependency in subpackages, if present.
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)
[x]: Bundled jar/class files should be removed before build

Maven:
[x]: Pom files have correct Maven mapping
     Note: Some add_maven_depmap calls found. Please check if they are correct
     or update to latest guidelines
[-]: If package contains pom.xml files install it (including depmaps) even
     when building with ant
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DOES NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use %{_mavenpomdir} instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).

     ---> except for javadoc-pkg, see above.

[x]: Package functions as described.
[-]: Latest version is packaged.

     ---> reasons see comment #2

[x]: Package does not include license text files separate from upstream.

     ---> there are additional files to upstream-provided LICENSE
          covering present multi-licensing with CPL and EPL,
          but that seems OK so far.

[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

Java:
[x]: Package uses upstream build method (ant/maven/etc.)
[x]: Packages are noarch unless they use JNI

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: groovy18-1.8.9-1.fc20.noarch.rpm
          groovy18-javadoc-1.8.9-1.fc20.noarch.rpm
groovy18.noarch: E: devel-dependency java-devel
groovy18.noarch: W: spelling-error %description -l en_US bytecode -> byte code, byte-code, decorate
groovy18.noarch: W: no-manual-page-for-binary groovy18sh
groovy18.noarch: W: no-manual-page-for-binary grape18
groovy18.noarch: W: no-manual-page-for-binary groovy18c
groovy18.noarch: W: no-manual-page-for-binary groovy18Console
groovy18.noarch: W: no-manual-page-for-binary groovy18
groovy18.noarch: W: no-manual-page-for-binary java2groovy18
2 packages and 0 specfiles checked; 1 errors, 7 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint groovy18 groovy18-javadoc
groovy18.noarch: E: devel-dependency java-devel
groovy18.noarch: W: spelling-error %description -l en_US bytecode -> byte code, byte-code, decorate
groovy18.noarch: W: no-manual-page-for-binary groovy18sh
groovy18.noarch: W: no-manual-page-for-binary grape18
groovy18.noarch: W: no-manual-page-for-binary groovy18c
groovy18.noarch: W: no-manual-page-for-binary groovy18Console
groovy18.noarch: W: no-manual-page-for-binary groovy18
groovy18.noarch: W: no-manual-page-for-binary java2groovy18
2 packages and 0 specfiles checked; 1 errors, 7 warnings.
# echo 'rpmlint-done:'



Requires
--------
groovy18 (rpmlib, GLIBC filtered):
    /bin/sh
    ant
    ant-junit
    antlr-tool
    apache-commons-cli
    apache-commons-logging
    apache-ivy
    bsf
    config(groovy18)
    jansi
    java-devel
    jline
    jpackage-utils
    junit
    objectweb-asm
    tomcat-jsp-2.2-api
    tomcat-servlet-3.0-api
    xstream

groovy18-javadoc (rpmlib, GLIBC filtered):
    groovy18
    jpackage-utils



Provides
--------
groovy18:
    config(groovy18)
    groovy18
    mvn(org.codehaus.groovy:groovy18)
    mvn(org.codehaus.groovy:groovy18-all)

groovy18-javadoc:
    groovy18-javadoc



Source checksums
----------------
http://dist.groovy.codehaus.org/distributions/groovy-src-1.8.9.zip :
  CHECKSUM(SHA256) this package     : 1edadb6e27816a7bad05dcaeb10ec4c839c9f66a2628dba9dcf0221aaa76076c
  CHECKSUM(SHA256) upstream package : 1edadb6e27816a7bad05dcaeb10ec4c839c9f66a2628dba9dcf0221aaa76076c


Generated by fedora-review 0.4.1 (b2e211f) last change: 2013-04-29
Buildroot used: fedora-rawhide-x86_64
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 858127

#####

This one is APPROVED!
Comment 5 gil cattaneo 2013-06-11 05:59:09 EDT
Thanks!

Spec URL: http://gil.fedorapeople.org/groovy18.spec
SRPM URL: http://gil.fedorapeople.org/groovy18-1.8.9-1.fc18.src.rpm

- removed jpackage-utils references from javadoc subpackages
- fixed spelling error

New Package SCM Request
=======================
Package Name: groovy18
Short Description: Dynamic language for the Java Platform
Owners: gil
Branches: f18 f19 f20
InitialCC: java-sig
Comment 6 Mikolaj Izdebski 2013-06-11 06:26:51 EDT
I want to highlight that this package does NOT follow packaging guidelines.

Groovy is already packaged for Fedora (package name "groovy") and I am a co-maintainer.

I perfectly understand that there is a need to maintain two versions of Groovy because some packages need version 2.x and some need 1.x and these two lines are incompatible.  But in this case groovy18 should be packaged as a compatibility package and follow packaging guidelines for compat packages [1].  This means that all JAR and POM files MUST be versioned (have -%{version} suffix).  If this rule is not followed then installing both groovy and groovy18 can lead to non-obvious errors during build or runtime of dependant packages.

I would like to ask you to fix and re-review the package to follow the guidelines in [1].

[1] http://fedoraproject.org/wiki/Packaging:Java#Compatibility_packages
Comment 7 Björn "besser82" Esser 2013-06-11 06:59:45 EDT
Created attachment 759559 [details]
Java Compat-pkg

Sorry, my bad. Missed that point.

Attached patch should fix this problem, I suppose?
Comment 8 Mikolaj Izdebski 2013-06-11 07:09:34 EDT
(In reply to Björn Esser from comment #7)
> Attached patch should fix this problem, I suppose?

Yes, with this patch the spec file looks fine in terms of compatibility package guidelines.

I suppose there may be other problems (wrong license tag, missing license files), wich I have recently fixed in groovy package and which should be backported.
Comment 9 gil cattaneo 2013-06-11 07:10:24 EDT
Spec URL: http://gil.fedorapeople.org/groovy18.spec
SRPM URL: http://gil.fedorapeople.org/groovy18-1.8.9-2.fc18.src.rpm

- packaged as a compatibility package
Comment 10 gil cattaneo 2013-06-11 07:38:54 EDT
(In reply to Mikolaj Izdebski from comment #8)
> (In reply to Björn Esser from comment #7)
> > Attached patch should fix this problem, I suppose?
> 
> Yes, with this patch the spec file looks fine in terms of compatibility
> package guidelines.
> 
alredy fixed
> I suppose there may be other problems (wrong license tag, missing license
> files), wich I have recently fixed in groovy package and which should be
> backported.
already fixed
regards
Comment 11 Björn "besser82" Esser 2013-06-11 07:41:08 EDT
(In reply to Mikolaj Izdebski from comment #8)
> I suppose there may be other problems (wrong license tag, missing license
> files), wich I have recently fixed in groovy package and which should be
> backported.

Checking the ~180 files with unknown license from source does not show or miss any license mentioned in spec-file. So this seems OK to me.

(In reply to gil cattaneo from comment #9)
> Spec URL: http://gil.fedorapeople.org/groovy18.spec
> SRPM URL: http://gil.fedorapeople.org/groovy18-1.8.9-2.fc18.src.rpm
> 
> - packaged as a compatibility package

re-reviewing shows objected compat-pkg issues are solved:

 * jar and pom are properly suffixed
 * no new issues

So finally (flag was set already):

APPROVED!
Comment 12 gil cattaneo 2013-06-11 07:48:16 EDT
thanks!

New Package SCM Request
=======================
Package Name: groovy18
Short Description: Dynamic language for the Java Platform
Owners: gil
Branches: f18 f19 f20
InitialCC: java-sig
Comment 13 Jon Ciesla 2013-06-11 07:59:40 EDT
Git done (by process-git-requests).
Comment 14 Fedora Update System 2013-06-11 10:15:05 EDT
groovy18-1.8.9-2.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/groovy18-1.8.9-2.fc19
Comment 15 Fedora Update System 2013-06-12 15:09:53 EDT
groovy18-1.8.9-2.fc19 has been pushed to the Fedora 19 testing repository.
Comment 16 Fedora Update System 2013-07-04 14:59:43 EDT
groovy18-1.8.9-3.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/groovy18-1.8.9-3.fc19

Note You need to log in before you can comment on or make changes to this bug.